Index: /palm/trunk/SOURCE/user_statistics.f90
===================================================================
--- /palm/trunk/SOURCE/user_statistics.f90	(revision 1319)
+++ /palm/trunk/SOURCE/user_statistics.f90	(revision 1320)
@@ -20,4 +20,11 @@
 ! Current revisions:
 ! -----------------
+! kind-parameters added to all INTEGER and REAL declaration statements, 
+! kinds are defined in new module kinds, 
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
+!
 !
 ! Former revisions:
@@ -30,16 +37,4 @@
 ! 1036 2012-10-22 13:43:42Z raasch
 ! code put under GPL (PALM 3.9)
-!
-! 678 2011-02-02 14:31:56Z raasch
-! Bugfix: module pegrid was missing
-!
-! 622 2010-12-10 08:08:13Z raasch
-! optional barriers included in order to speed up collective operations
-!
-! 555 2010-09-07 07:32:53Z raasch
-! Bugfix: wrong dimension used for ts_value_l
-!
-! 493 2010-03-01 08:30:24Z raasch
-! Bugfix: timeseries data have to be collected by PE0
 !
 ! 211 2008-11-11 04:46:24Z raasch
@@ -57,17 +52,30 @@
 
     USE arrays_3d
+    
     USE indices
+    
+    USE kinds
+    
     USE netcdf_control
+    
     USE pegrid
+    
     USE statistics
+    
     USE user
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  mode
+    CHARACTER (LEN=*) ::  mode   !: 
 
-    INTEGER ::  i, j, k, sr, tn
+    INTEGER(iwp) ::  i    !: 
+    INTEGER(iwp) ::  j    !: 
+    INTEGER(iwp) ::  k    !: 
+    INTEGER(iwp) ::  sr   !: 
+    INTEGER(iwp) ::  tn   !: 
 
-    REAL, DIMENSION(dots_num_palm+1:dots_max) ::  ts_value_l
+    REAL(wp),                                                                  &
+       DIMENSION(dots_num_palm+1:dots_max) ::                                  &
+          ts_value_l   !: 
 
 
@@ -87,12 +95,12 @@
 !!--             Sample on how to calculate the profile of the resolved-scale
 !!--             horizontal momentum flux u*v*
-!                sums_l(k,pr_palm+1,tn) = sums_l(k,pr_palm+1,tn) +           &
-!                      ( 0.5 * ( u(k,j,i) + u(k,j,i+1) ) - hom(k,1,1,sr) ) * &
-!                      ( 0.5 * ( v(k,j,i) + v(k,j+1,i) ) - hom(k,1,2,sr) )   &
+!                sums_l(k,pr_palm+1,tn) = sums_l(k,pr_palm+1,tn) +               &
+!                      ( 0.5 * ( u(k,j,i) + u(k,j,i+1) ) - hom(k,1,1,sr) ) *     &
+!                      ( 0.5 * ( v(k,j,i) + v(k,j+1,i) ) - hom(k,1,2,sr) )       &
 !                                                 * rmask(j,i,sr)
 !!
 !!--             Further profiles can be defined and calculated by increasing
 !!--             the second index of array sums_l (replace ... appropriately)
-!                sums_l(k,pr_palm+2,tn) = sums_l(k,pr_palm+2,tn) + ... &
+!                sums_l(k,pr_palm+2,tn) = sums_l(k,pr_palm+2,tn) + ...           &
 !                                         * rmask(j,i,sr)
 !             ENDDO
@@ -121,7 +129,7 @@
 !#if defined( __parallel ) && ! defined ( __check )
 !       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-!       CALL MPI_ALLREDUCE( ts_value_l(dots_num_palm+1),                       &
-!                           ts_value(dots_num_palm+1,sr),                      &
-!                           dots_max-dots_num_palm, MPI_REAL, MPI_SUM, comm2d, &
+!       CALL MPI_ALLREDUCE( ts_value_l(dots_num_palm+1),                         &
+!                           ts_value(dots_num_palm+1,sr),                        &
+!                           dots_max-dots_num_palm, MPI_REAL, MPI_SUM, comm2d,   &
 !                           ierr )
 !#else
Index: /palm/trunk/SOURCE/wall_fluxes.f90
===================================================================
--- /palm/trunk/SOURCE/wall_fluxes.f90	(revision 1319)
+++ /palm/trunk/SOURCE/wall_fluxes.f90	(revision 1320)
@@ -20,4 +20,11 @@
 ! Current revisions:
 ! -----------------
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements, 
+! kinds are defined in new module kinds, 
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 !
@@ -41,15 +48,4 @@
 ! 1015 2012-09-27 09:23:24Z raasch
 ! accelerator version (*_acc) added
-!
-! 187 2008-08-06 16:25:09Z letzel
-! Bugfix: Modification of the evaluation of the vertical turbulent momentum 
-! fluxes u'w' and v'w (see prandtl_fluxes), this requires the calculation of
-! us_wall (and vel_total, u_i, v_i, ws) also in wall_fluxes_e.
-! Bugfix: change definition of us_wall from 1D to 2D
-! Bugfix: storage of rifs to rifs_wall in wall_fluxes_e removed
-! Change: add 'minus' sign to fluxes produced by subroutine wall_fluxes_e for 
-! consistency with subroutine wall_fluxes
-! Change: Modification of the integrated version of the profile function for 
-! momentum for unstable stratification
 !
 ! Initial version (2007/03/07)
@@ -90,24 +86,62 @@
 ! Call for all grid points
 !------------------------------------------------------------------------------!
-    SUBROUTINE wall_fluxes( wall_flux, a, b, c1, c2, nzb_uvw_inner, &
+    SUBROUTINE wall_fluxes( wall_flux, a, b, c1, c2, nzb_uvw_inner,            &
                             nzb_uvw_outer, wall )
 
-       USE arrays_3d
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  rif_wall, u, v, w, z0, pt
+       
+       USE control_parameters,                                                 &
+           ONLY:  g, kappa, rif_max, rif_min
+       
+       USE grid_variables,                                                     &
+           ONLY:  dx, dy
+       
+       USE indices,                                                            &
+           ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
+       
+       USE kinds
+       
+       USE statistics,                                                         &
+           ONLY:  hom
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k, wall_index
-
-       INTEGER, DIMENSION(nysg:nyng,nxlg:nxrg) ::  nzb_uvw_inner, &
-                                                       nzb_uvw_outer
-       REAL ::  a, b, c1, c2, h1, h2, zp
-       REAL ::  pts, pt_i, rifs, u_i, v_i, us_wall, vel_total, ws, wspts
-
-       REAL, DIMENSION(nysg:nyng,nxlg:nxrg)   ::  wall
-       REAL, DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  wall_flux
+       INTEGER(iwp) ::  i            !: 
+       INTEGER(iwp) ::  j            !: 
+       INTEGER(iwp) ::  k            !: 
+       INTEGER(iwp) ::  wall_index   !: 
+
+       INTEGER(iwp),                                                           &
+          DIMENSION(nysg:nyng,nxlg:nxrg) ::                                    &
+             nzb_uvw_inner   !: 
+       INTEGER(iwp),                                                           &
+          DIMENSION(nysg:nyng,nxlg:nxrg) ::                                    &
+             nzb_uvw_outer   !: 
+       
+       REAL(wp) ::  a           !: 
+       REAL(wp) ::  b           !: 
+       REAL(wp) ::  c1          !: 
+       REAL(wp) ::  c2          !: 
+       REAL(wp) ::  h1          !: 
+       REAL(wp) ::  h2          !: 
+       REAL(wp) ::  zp          !: 
+       REAL(wp) ::  pts         !: 
+       REAL(wp) ::  pt_i        !: 
+       REAL(wp) ::  rifs        !: 
+       REAL(wp) ::  u_i         !: 
+       REAL(wp) ::  v_i         !: 
+       REAL(wp) ::  us_wall     !: 
+       REAL(wp) ::  vel_total   !: 
+       REAL(wp) ::  ws          !: 
+       REAL(wp) ::  wspts       !: 
+
+       REAL(wp),                                                               &
+          DIMENSION(nysg:nyng,nxlg:nxrg) ::                                    &
+             wall   !: 
+       
+       REAL(wp),                                                               &
+          DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::                              &
+             wall_flux   !: 
 
 
@@ -129,8 +163,8 @@
                    rifs  = rif_wall(k,j,i,wall_index)
 
-                   u_i   = a * u(k,j,i) + c1 * 0.25 * &
+                   u_i   = a * u(k,j,i) + c1 * 0.25 *                          &
                            ( u(k+1,j,i+1) + u(k+1,j,i) + u(k,j,i+1) + u(k,j,i) )
 
-                   v_i   = b * v(k,j,i) + c2 * 0.25 * &
+                   v_i   = b * v(k,j,i) + c2 * 0.25 *                          &
                            ( v(k+1,j+1,i) + v(k+1,j,i) + v(k,j+1,i) + v(k,j,i) )
 
@@ -139,5 +173,5 @@
                    + b * ( w(k-1,j-1,i) + w(k-1,j,i) + w(k,j-1,i) + w(k,j,i) ) &
                                                            )
-                   pt_i  = 0.5 * ( pt(k,j,i) + a *  pt(k,j,i-1) + &
+                   pt_i  = 0.5 * ( pt(k,j,i) + a *  pt(k,j,i-1) +              &
                                    b * pt(k,j-1,i) + ( c1 + c2 ) * pt(k+1,j,i) )
 
@@ -176,5 +210,5 @@
 !--                (4) Compute zp/L (corresponds to neutral Richardson flux
 !--                    number rifs)
-                   rifs = -1.0 * zp * kappa * g * wspts / ( pt_i * &
+                   rifs = -1.0 * zp * kappa * g * wspts / ( pt_i *             &
                                                         ( us_wall**3 + 1E-30 ) )
 
@@ -234,24 +268,65 @@
 ! Call for all grid points - accelerator version
 !------------------------------------------------------------------------------!
-    SUBROUTINE wall_fluxes_acc( wall_flux, a, b, c1, c2, nzb_uvw_inner, &
+    SUBROUTINE wall_fluxes_acc( wall_flux, a, b, c1, c2, nzb_uvw_inner,        &
                                 nzb_uvw_outer, wall )
 
-       USE arrays_3d
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  rif_wall, pt, u, v, w, z0
+       
+       USE control_parameters,                                                 &
+           ONLY:  g, kappa, rif_max, rif_min
+       
+       USE grid_variables,                                                     &
+           ONLY:  dx, dy
+       
+       USE indices,                                                            &
+           ONLY:  i_left, i_right, j_north, j_south, nxl, nxlg, nxr, nxrg,     &
+                  nyn, nyng, nys, nysg, nzb, nzt
+       
+       USE kinds
+       
+       USE statistics,                                                         &
+           ONLY:  hom
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k, max_outer, min_inner, wall_index
-
-       INTEGER, DIMENSION(nysg:nyng,nxlg:nxrg) ::  nzb_uvw_inner, &
-                                                   nzb_uvw_outer
-       REAL ::  a, b, c1, c2, h1, h2, zp
-       REAL ::  pts, pt_i, rifs, u_i, v_i, us_wall, vel_total, ws, wspts
-
-       REAL, DIMENSION(nysg:nyng,nxlg:nxrg)   ::  wall
-       REAL, DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  wall_flux
+       INTEGER(iwp) ::  i            !: 
+       INTEGER(iwp) ::  j            !: 
+       INTEGER(iwp) ::  k            !: 
+       INTEGER(iwp) ::  max_outer    !: 
+       INTEGER(iwp) ::  min_inner    !: 
+       INTEGER(iwp) ::  wall_index   !: 
+
+       INTEGER(iwp),                                                           &
+          DIMENSION(nysg:nyng,nxlg:nxrg) ::                                    &
+             nzb_uvw_inner   !: 
+       INTEGER(iwp),                                                           &
+          DIMENSION(nysg:nyng,nxlg:nxrg) ::                                    &
+             nzb_uvw_outer   !: 
+       
+       REAL(wp) ::  a           !: 
+       REAL(wp) ::  b           !: 
+       REAL(wp) ::  c1          !: 
+       REAL(wp) ::  c2          !: 
+       REAL(wp) ::  h1          !: 
+       REAL(wp) ::  h2          !: 
+       REAL(wp) ::  zp          !: 
+       REAL(wp) ::  pts         !: 
+       REAL(wp) ::  pt_i        !: 
+       REAL(wp) ::  rifs        !: 
+       REAL(wp) ::  u_i         !: 
+       REAL(wp) ::  v_i         !: 
+       REAL(wp) ::  us_wall     !: 
+       REAL(wp) ::  vel_total   !: 
+       REAL(wp) ::  ws          !: 
+       REAL(wp) ::  wspts       !: 
+
+       REAL(wp),                                                               &
+          DIMENSION(nysg:nyng,nxlg:nxrg) ::                                    &
+             wall   !: 
+       
+       REAL(wp),                                                               &
+          DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::                              &
+             wall_flux   !: 
 
 
@@ -280,8 +355,8 @@
                    rifs  = rif_wall(k,j,i,wall_index)
 
-                   u_i   = a * u(k,j,i) + c1 * 0.25 * &
+                   u_i   = a * u(k,j,i) + c1 * 0.25 *                          &
                            ( u(k+1,j,i+1) + u(k+1,j,i) + u(k,j,i+1) + u(k,j,i) )
 
-                   v_i   = b * v(k,j,i) + c2 * 0.25 * &
+                   v_i   = b * v(k,j,i) + c2 * 0.25 *                          &
                            ( v(k+1,j+1,i) + v(k+1,j,i) + v(k,j+1,i) + v(k,j,i) )
 
@@ -290,5 +365,5 @@
                    + b * ( w(k-1,j-1,i) + w(k-1,j,i) + w(k,j-1,i) + w(k,j,i) ) &
                                                            )
-                   pt_i  = 0.5 * ( pt(k,j,i) + a *  pt(k,j,i-1) + &
+                   pt_i  = 0.5 * ( pt(k,j,i) + a *  pt(k,j,i-1) +              &
                                    b * pt(k,j-1,i) + ( c1 + c2 ) * pt(k+1,j,i) )
 
@@ -327,5 +402,5 @@
 !--                (4) Compute zp/L (corresponds to neutral Richardson flux
 !--                    number rifs)
-                   rifs = -1.0 * zp * kappa * g * wspts / ( pt_i * &
+                   rifs = -1.0 * zp * kappa * g * wspts / ( pt_i *             &
                                                         ( us_wall**3 + 1E-30 ) )
 
@@ -372,6 +447,4 @@
                    rif_wall(k,j,i,wall_index) = rifs
 
-!                ENDIF
-
                 ENDDO
 
@@ -390,18 +463,48 @@
     SUBROUTINE wall_fluxes_ij( i, j, nzb_w, nzt_w, wall_flux, a, b, c1, c2 )
 
-       USE arrays_3d
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  rif_wall, pt, u, v, w, z0
+       
+       USE control_parameters,                                                 &
+           ONLY:  g, kappa, rif_max, rif_min
+       
+       USE grid_variables,                                                     &
+           ONLY:  dx, dy
+       
+       USE indices,                                                            &
+           ONLY:  nzb, nzt
+       
+       USE kinds
+       
+       USE statistics,                                                         &
+           ONLY:  hom
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k, nzb_w, nzt_w, wall_index
-       REAL    ::  a, b, c1, c2, h1, h2, zp
-
-       REAL ::  pts, pt_i, rifs, u_i, v_i, us_wall, vel_total, ws, wspts
-
-       REAL, DIMENSION(nzb:nzt+1) ::  wall_flux
+       INTEGER(iwp) ::  i            !: 
+       INTEGER(iwp) ::  j            !: 
+       INTEGER(iwp) ::  k            !: 
+       INTEGER(iwp) ::  nzb_w        !: 
+       INTEGER(iwp) ::  nzt_w        !: 
+       INTEGER(iwp) ::  wall_index   !: 
+       
+       REAL(wp) ::  a           !: 
+       REAL(wp) ::  b           !: 
+       REAL(wp) ::  c1          !: 
+       REAL(wp) ::  c2          !: 
+       REAL(wp) ::  h1          !: 
+       REAL(wp) ::  h2          !: 
+       REAL(wp) ::  zp          !: 
+       REAL(wp) ::  pts         !: 
+       REAL(wp) ::  pt_i        !: 
+       REAL(wp) ::  rifs        !: 
+       REAL(wp) ::  u_i         !: 
+       REAL(wp) ::  v_i         !: 
+       REAL(wp) ::  us_wall     !: 
+       REAL(wp) ::  vel_total   !: 
+       REAL(wp) ::  ws          !: 
+       REAL(wp) ::  wspts       !: 
+
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  wall_flux   !: 
 
 
@@ -419,8 +522,8 @@
           rifs  = rif_wall(k,j,i,wall_index)
 
-          u_i   = a * u(k,j,i) + c1 * 0.25 * &
+          u_i   = a * u(k,j,i) + c1 * 0.25 *                                   &
                   ( u(k+1,j,i+1) + u(k+1,j,i) + u(k,j,i+1) + u(k,j,i) )
 
-          v_i   = b * v(k,j,i) + c2 * 0.25 * &
+          v_i   = b * v(k,j,i) + c2 * 0.25 *                                   &
                   ( v(k+1,j+1,i) + v(k+1,j,i) + v(k,j+1,i) + v(k,j,i) )
 
@@ -429,5 +532,5 @@
                    + b * ( w(k-1,j-1,i) + w(k-1,j,i) + w(k,j-1,i) + w(k,j,i) ) &
                                                   )
-          pt_i  = 0.5 * ( pt(k,j,i) + a *  pt(k,j,i-1) + b * pt(k,j-1,i)  &
+          pt_i  = 0.5 * ( pt(k,j,i) + a *  pt(k,j,i-1) + b * pt(k,j-1,i)       &
                           + ( c1 + c2 ) * pt(k+1,j,i) )
 
@@ -455,9 +558,9 @@
              h2 = SQRT( SQRT( 1.0 - 16.0 * rifs * z0(j,i) / zp ) )
 
-             us_wall = kappa * vel_total / (                          &
-                  LOG( zp / z0(j,i) ) -                               &
-                  LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (          &
-                       ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +      &
-                       2.0 * ( ATAN( h1 ) - ATAN( h2 ) )              &
+             us_wall = kappa * vel_total / (                                   &
+                  LOG( zp / z0(j,i) ) -                                        &
+                  LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (                   &
+                       ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +               &
+                       2.0 * ( ATAN( h1 ) - ATAN( h2 ) )                       &
                                            )
           ENDIF
@@ -483,8 +586,8 @@
 !
 !--          Stable stratification (and neutral)
-             wall_flux(k) = kappa *                                          &
-                            ( a*u(k,j,i) + b*v(k,j,i) + (c1+c2)*w(k,j,i) ) / &
-                            (  LOG( zp / z0(j,i) ) +                         &
-                               5.0 * rifs * ( zp - z0(j,i) ) / zp            &
+             wall_flux(k) = kappa *                                            &
+                            ( a*u(k,j,i) + b*v(k,j,i) + (c1+c2)*w(k,j,i) ) /   &
+                            (  LOG( zp / z0(j,i) ) +                           &
+                               5.0 * rifs * ( zp - z0(j,i) ) / zp              &
                             )
           ELSE
@@ -495,10 +598,10 @@
              h2 = SQRT( SQRT( 1.0 - 16.0 * rifs * z0(j,i) / zp ) )
 
-             wall_flux(k) = kappa *                               &
-                  ( a*u(k,j,i) + b*v(k,j,i) + (c1+c2)*w(k,j,i) ) / (  &
-                  LOG( zp / z0(j,i) ) -                               &
-                  LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (          &
-                       ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +      &
-                       2.0 * ( ATAN( h1 ) - ATAN( h2 ) )              &
+             wall_flux(k) = kappa *                                            &
+                  ( a*u(k,j,i) + b*v(k,j,i) + (c1+c2)*w(k,j,i) ) / (           &
+                  LOG( zp / z0(j,i) ) -                                        &
+                  LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (                   &
+                       ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +               &
+                       2.0 * ( ATAN( h1 ) - ATAN( h2 ) )                       &
                                                                    )
           ENDIF
@@ -528,20 +631,49 @@
 !------------------------------------------------------------------------------!
 
-       USE arrays_3d
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  rif_wall, u, v, w, z0
+       
+       USE control_parameters,                                                 &
+           ONLY:  kappa
+       
+       USE grid_variables,                                                     &
+           ONLY:  dx, dy
+       
+       USE indices,                                                            &
+           ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb,             &
+                  nzb_diff_s_inner, nzb_diff_s_outer, nzt
+       
+       USE kinds
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k, kk, wall_index
-       REAL    ::  a, b, c1, c2, h1, h2, u_i, v_i, us_wall, vel_total, vel_zp, &
-                   ws, zp
-
-       REAL ::  rifs
-
-       REAL, DIMENSION(nysg:nyng,nxlg:nxrg)   ::  wall
-       REAL, DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  wall_flux
+       INTEGER(iwp) ::  i            !: 
+       INTEGER(iwp) ::  j            !: 
+       INTEGER(iwp) ::  k            !: 
+       INTEGER(iwp) ::  kk           !: 
+       INTEGER(iwp) ::  wall_index   !: 
+       
+       REAL(wp) ::  a           !: 
+       REAL(wp) ::  b           !: 
+       REAL(wp) ::  c1          !: 
+       REAL(wp) ::  c2          !: 
+       REAL(wp) ::  h1          !: 
+       REAL(wp) ::  h2          !: 
+       REAL(wp) ::  u_i         !: 
+       REAL(wp) ::  v_i         !: 
+       REAL(wp) ::  us_wall     !: 
+       REAL(wp) ::  vel_total   !: 
+       REAL(wp) ::  vel_zp      !: 
+       REAL(wp) ::  ws          !: 
+       REAL(wp) ::  zp          !: 
+       REAL(wp) ::  rifs        !: 
+
+       REAL(wp),                                                               &
+          DIMENSION(nysg:nyng,nxlg:nxrg) ::                                    &
+             wall   !: 
+       
+       REAL(wp),                                                               &
+          DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::                              &
+             wall_flux   !: 
 
 
@@ -611,5 +743,5 @@
 !
 !--                   Stable stratification (and neutral)
-                      wall_flux(k,j,i) = kappa *  vel_zp / &
+                      wall_flux(k,j,i) = kappa *  vel_zp /                     &
                           ( LOG( zp/z0(j,i) ) + 5.0*rifs * ( zp-z0(j,i) ) / zp )
                    ELSE
@@ -652,20 +784,52 @@
 !------------------------------------------------------------------------------!
 
-       USE arrays_3d
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  rif_wall, u, v, w, z0
+       
+       USE control_parameters,                                                 &
+           ONLY:  kappa
+       
+       USE grid_variables,                                                     &
+           ONLY:  dx, dy
+       
+       USE indices,                                                            &
+           ONLY:  i_left, i_right, j_north, j_south, nxl, nxlg, nxr, nxrg,     &
+                  nyn, nyng, nys, nysg, nzb, nzb_diff_s_inner,                 &
+                  nzb_diff_s_outer, nzt
+       
+       USE kinds
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k, kk, max_outer, min_inner, wall_index
-       REAL    ::  a, b, c1, c2, h1, h2, u_i, v_i, us_wall, vel_total, vel_zp, &
-                   ws, zp
-
-       REAL ::  rifs
-
-       REAL, DIMENSION(nysg:nyng,nxlg:nxrg)   ::  wall
-       REAL, DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  wall_flux
+       INTEGER(iwp) ::  i            !: 
+       INTEGER(iwp) ::  j            !: 
+       INTEGER(iwp) ::  k            !: 
+       INTEGER(iwp) ::  kk           !: 
+       INTEGER(iwp) ::  max_outer    !: 
+       INTEGER(iwp) ::  min_inner    !: 
+       INTEGER(iwp) ::  wall_index   !: 
+       
+       REAL(wp) ::  a           !: 
+       REAL(wp) ::  b           !: 
+       REAL(wp) ::  c1          !: 
+       REAL(wp) ::  c2          !: 
+       REAL(wp) ::  h1          !: 
+       REAL(wp) ::  h2          !: 
+       REAL(wp) ::  u_i         !: 
+       REAL(wp) ::  v_i         !: 
+       REAL(wp) ::  us_wall     !: 
+       REAL(wp) ::  vel_total   !: 
+       REAL(wp) ::  vel_zp      !: 
+       REAL(wp) ::  ws          !: 
+       REAL(wp) ::  zp          !: 
+       REAL(wp) ::  rifs        !: 
+
+       REAL(wp),                                                               &
+          DIMENSION(nysg:nyng,nxlg:nxrg) ::                                    &
+             wall   !: 
+       
+       REAL(wp),                                                               &
+          DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::                              &
+             wall_flux   !: 
 
 
@@ -684,5 +848,5 @@
 !
 !--             All subsequent variables are computed for scalar locations
-                IF ( k >= nzb_diff_s_inner(j,i)-1  .AND. &
+                IF ( k >= nzb_diff_s_inner(j,i)-1  .AND.                       &
                      k <= nzb_diff_s_outer(j,i)-2  .AND.  wall(j,i) /= 0.0 )  THEN
 !
@@ -740,5 +904,5 @@
 !
 !--                   Stable stratification (and neutral)
-                      wall_flux(k,j,i) = kappa *  vel_zp / &
+                      wall_flux(k,j,i) = kappa *  vel_zp /                     &
                           ( LOG( zp/z0(j,i) ) + 5.0*rifs * ( zp-z0(j,i) ) / zp )
                    ELSE
@@ -773,19 +937,44 @@
     SUBROUTINE wall_fluxes_e_ij( i, j, nzb_w, nzt_w, wall_flux, a, b, c1, c2 )
 
-       USE arrays_3d
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  rif_wall, u, v, w, z0
+       
+       USE control_parameters,                                                 &
+           ONLY:  kappa
+       
+       USE grid_variables,                                                     &
+           ONLY:  dx, dy
+       
+       USE indices,                                                            &
+           ONLY:  nzb, nzt
+       
+       USE kinds
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k, kk, nzb_w, nzt_w, wall_index
-       REAL    ::  a, b, c1, c2, h1, h2, u_i, v_i, us_wall, vel_total, vel_zp, &
-                   ws, zp
-
-       REAL ::  rifs
-
-       REAL, DIMENSION(nzb:nzt+1) ::  wall_flux
+       INTEGER(iwp) ::  i            !: 
+       INTEGER(iwp) ::  j            !: 
+       INTEGER(iwp) ::  k            !: 
+       INTEGER(iwp) ::  kk           !: 
+       INTEGER(iwp) ::  nzb_w        !: 
+       INTEGER(iwp) ::  nzt_w        !: 
+       INTEGER(iwp) ::  wall_index   !: 
+       
+       REAL(wp) ::  a           !: 
+       REAL(wp) ::  b           !: 
+       REAL(wp) ::  c1          !: 
+       REAL(wp) ::  c2          !: 
+       REAL(wp) ::  h1          !: 
+       REAL(wp) ::  h2          !: 
+       REAL(wp) ::  u_i         !: 
+       REAL(wp) ::  v_i         !: 
+       REAL(wp) ::  us_wall     !: 
+       REAL(wp) ::  vel_total   !: 
+       REAL(wp) ::  vel_zp      !: 
+       REAL(wp) ::  ws          !: 
+       REAL(wp) ::  zp          !: 
+       REAL(wp) ::  rifs        !: 
+
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  wall_flux   !: 
 
 
@@ -834,9 +1023,9 @@
              h2 = SQRT( SQRT( 1.0 - 16.0 * rifs * z0(j,i) / zp ) )
 
-             us_wall = kappa * vel_total / (                          &
-                  LOG( zp / z0(j,i) ) -                               &
-                  LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (          &
-                       ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +      &
-                       2.0 * ( ATAN( h1 ) - ATAN( h2 ) )              &
+             us_wall = kappa * vel_total / (                                   &
+                  LOG( zp / z0(j,i) ) -                                        &
+                  LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (                   &
+                       ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +               &
+                       2.0 * ( ATAN( h1 ) - ATAN( h2 ) )                       &
                                            )
           ENDIF
@@ -850,7 +1039,7 @@
 !--       subroutine wall_fluxes because fluxes in subroutine 
 !--       wall_fluxes_e are defined at scalar locations).
-          vel_zp = 0.5 * (       a * ( u(k,j,i) + u(k,j,i+1) ) +  &
-                                 b * ( v(k,j,i) + v(k,j+1,i) ) +  &
-                           (c1+c2) * ( w(k,j,i) + w(k-1,j,i) )    &
+          vel_zp = 0.5 * (       a * ( u(k,j,i) + u(k,j,i+1) ) +               &
+                                 b * ( v(k,j,i) + v(k,j+1,i) ) +               &
+                           (c1+c2) * ( w(k,j,i) + w(k-1,j,i) )                 &
                          )
 
@@ -859,5 +1048,5 @@
 !
 !--          Stable stratification (and neutral)
-             wall_flux(k) = kappa *  vel_zp / &
+             wall_flux(k) = kappa *  vel_zp /                                  &
                           ( LOG( zp/z0(j,i) ) + 5.0*rifs * ( zp-z0(j,i) ) / zp )
           ELSE
@@ -868,9 +1057,9 @@
              h2 = SQRT( SQRT( 1.0 - 16.0 * rifs * z0(j,i) / zp ) )
 
-             wall_flux(k) = kappa * vel_zp / (                        &
-                  LOG( zp / z0(j,i) ) -                               &
-                  LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (          &
-                       ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +      &
-                       2.0 * ( ATAN( h1 ) - ATAN( h2 ) )              &
+             wall_flux(k) = kappa * vel_zp / (                                 &
+                  LOG( zp / z0(j,i) ) -                                        &
+                  LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (                   &
+                       ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +               &
+                       2.0 * ( ATAN( h1 ) - ATAN( h2 ) )                       &
                                                  )
           ENDIF
